ad_page_contract { 
    Check docbook files are valid XML

    @author Jeff Davis (davis@xarg.net)
    @creation-date 2002-09-02
    @cvs-id $Id: docbook.tcl,v 1.2 2002/10/14 11:10:22 davis Exp $
} { 
    {package:trim {}}
}

ReturnHeaders 

proc ::xml_p {file} { 
    return [expr [string match {*.xml} $file] || [file isdirectory $file]]
}

# Get some stuff out of the index.xml file.
set fp [open "[acs_root_dir]/packages/acs-core-docs/www/xml/index.xml" "r"]
set data [read $fp]
close $fp
# Pull out the DTD with the entities...
set entities "<!DOCTYPE book PUBLIC \"-//OASIS//DTD DocBook XML V4.1.2//EN\"
               \"http://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd\" \["
while {[regexp {(<!ENTITY[^>]*>)(.*)} $data match entity data]} { 
    append entities $entity
}
append entities "\]>"

# Walk the files...
foreach file [ad_find_all_files -check_file_func ::xml_p [acs_root_dir]/packages/acs-core-docs/] { 
    if {[string match {*index.xml} $file]} { 
        continue
    }
    ns_write "\n$file\n"
    set fp [open $file "r"]
    set data [read $fp]
    close $fp
    if ![regexp {^<[?]xml version=} $data] { 
        set data "<?xml version=\"1.0\"?>$data"
    }

    regsub {^(<[?]xml version=['"]1.0['"][?]>)} $data "\\1$entities" data

    #ns_write "<br><br>[ad_quotehtml $data]"

    if { [catch {set parse [xml_parse -persist $data]} errMsg] } { 
        ns_write "Error: <pre>$errMsg</pre>\n"
    } else { 
        # lets walk the nodes and just make sure the sect#s nest properly
        # We could write a fancy XSLT script to do this 
        # but I am a monkey and can't understand xslt at all
        
        
        # We are done so just let it go man.
        xml_doc_free $parse
    }
}


