ad_page_contract { 
    Check info files for internal consistency 
    and file manifest etc.

    @author Jeff Davis (davis@xarg.net)
    @creation-date 2002-08-10
    @cvs-id $Id: info.tcl,v 1.2 2002/10/14 11:10:22 davis Exp $
} { 
    {package:trim {}}
} -properties { 
    fstat:multirow
    bad:multirow
    context:onevalue
}

multirow create fstat status package file 
multirow create bad package message 

if {![empty_string_p $package]} { 
    regsub {^/*} $package / package
} else { 
    set package {/*}
}
foreach spec_file [glob -nocomplain "[acs_root_dir]/packages$package/*.info"] {
     if {  [catch {array set version [apm_read_package_info_file $spec_file]} errMsg] } {
         multirow append bad $spec_file "PARSE FAILED: $spec_file: $errMsg"
     } else {
         regexp {packages/([^/]*)/} $spec_file match key

         
         if {![string equal $version(package.key) $key]} { 
             multirow append bad $spec_file "MISMATCH DIRECTORY/PACKAGE KEY: $spec_file $version(package.key) != $key"
         }

         # check on the 
         if {[empty_string_p $version(provides)] && [string equal $version(package.type) apm_service] } { 

             multirow append bad $spec_file "SERVICE MISSING PROVIDES: $key"
         } elseif { ![empty_string_p $version(provides)]} { 
             if { ![string equal $version(name) [lindex [lindex $version(provides) 0] 1]]} { 
                 multirow append bad $spec_file "MISMATCH PROVIDES VERSION:  $version(provides) $version(name)"
             }
             if { ![string equal $key [lindex [lindex $version(provides) 0] 0]]} { 
                 multirow append bad $spec_file "MISMATCH PROVIDES KEY: $key $version(provides)"
             }
         }
             

         array unset files
         set seen 0
         foreach file $version(files)  { 
             set files([lindex $file 0]) $file
         }
         foreach file [lsort [ad_find_all_files \
                                  -check_file_func apm_include_file_p \
                                  [acs_package_root_dir $version(package.key)]]] {

             # trim down to match filenames in .info file.
             set relative_path [ad_make_relative_path $file]
             set components [split $relative_path "/"]
             set relative_path [join [lrange $components 2 [llength $components]] "/"]

             if {![info exists files($relative_path)]} { 
                 multirow append fstat missing $spec_file $relative_path
             } else { 
                 unset files($relative_path)
             }
         }
         # any files left now were not found in the filesystem
         foreach file [lsort [array names files]] { 
             multirow append fstat deleted $spec_file $file
         }

     }
}

set context [list "check info files"]
