package provide nstclhttpd::parser 1.0

package require nstclhttpd::parser::cmd

namespace eval ns {}
namespace eval ns::parser {}

set ns::parser::defrc [list]

proc ns::parser::parse_dodqe {cmd} {
    upvar rc rc
    if {[regexp "^(.*?)\[ \n\](.*)\$" $cmd "" cmd ar]} {
        set xcmd cmd_$cmd
        if {[catch {$xcmd $ar} er]} {
            #lappend rc "t<!-- $xcmd error: $er -->"
            ns_log error "dq-e parser:\n$::errorInfo"
        }  else  {
            set rc [concat $rc $er]
        }
    }  else  {
        set xcmd cmd_$cmd
        if {[catch {$xcmd} er]} {
            #lappend rc "t<!-- $xcmd error: $er -->"
            ns_log error "dq-e parser:\n$::errorInfo"
        }  else  {
            set rc [concat $rc $er]
        }
    }
}

proc ns::parser::parse {b} {
    variable defrc
    set rc $defrc
    set idx 0
    while {1} {
        set i0 [string first "<%" $b $idx]
        set i1 [string first "<!-- dq-e:" $b $idx]
        if {($i0>=0)&&($i1>=0)} {
            if {$i0<$i1} {set cmode 0}  else  {set cmode 1}
        }  elseif  {$i0>=0} {
            set cmode 0
        }  elseif  {$i1>=0} {
            set cmode 1
        }  else  {
            lappend rc t[string range $b $idx end]
            break
        }
        if {$cmode==0} {
            # ADP
            lappend rc t[string range $b $idx [expr {$i0-1}]]
            set adpend [string first "%>" $b $i0]
            if {$adpend>0} {
                set idx [expr {$adpend+2}]
                set adp [string range $b [expr {$i0+2}] [expr {$adpend-1}]]
                if {[string index $adp 0]=="="} {
                    lappend rc "sns_puts -nonewline [string range $adp 1 end]"
                }  elseif {[string index $adp 0]=="!"} {
                    parse_dodqe [string range $adp 1 end]
                }  else  {
                    lappend rc s$adp
                }
            }  else  {
                set idx [expr {[string length $b]}]
            }
        }  else  {
            # dq-e
            lappend rc t[string range $b $idx [expr {$i1-1}]]
            set dqeend [string first "-->" $b $i1]
            if {$dqeend>0} {
                set idx [expr {$dqeend+3}]
                set cmd [string trim [string range $b [expr {$i1+10}] [expr {$dqeend-1}]]]
                parse_dodqe $cmd
            }  else  {
                set idx [expr {[string length $b]}]
            }
        }
    }
    return $rc
}

