package provide nstclhttpd::adp 1.0
package require nstclhttpd::core
package require nstclhttpd::parser

namespace eval ns {}
namespace eval ns::adp {}

if {![info exists ns::adp::buffer]} {
    set ns::adp::buffer ""
}
if {![info exists ns::adp::arguments]} {
    set ns::adp::arguments ""
}
if {![info exists ns::adp::filehistory]} {
    set ns::adp::filehistory [list]
}

ad_proc ns::adp::parse {lvl file arg} {
    variable filehistory
    variable buffer
    variable arguments

    set fh [open $file r]
    fconfigure $fh -encoding $::ns::encoding -translation auto
    set fc [read $fh]
    close $fh

    set parsed [ns::parser::parse $fc]
    set filehistory [linsert $filehistory 0 $file]
    set buf $buffer
    set ar $arguments

    set buffer ""
    set code ok
    set arguments [concat [list $file] $arg]

    foreach part $parsed {
        set pe [string range $part 1 end]
        switch -- [string index $part 0] {
            s {
                set c [catch {uplevel $lvl $pe} rc]
                if {($c==3)||($c==4)} {
                    break
                }  elseif  {$c==2} {
                    set code return
                    break
                }  elseif  {$c==1} {
                    bgerror $rc
                }
            }
            t {
                append buffer $pe
            }
        }
    }

    set rc $buffer
    set arguments $ar

    set buffer $buf
    set filehistory [lrange $filehistory 1 end]
    return -code $code $rc
}

ad_proc ns::adp::adpdir {} {
    variable filehistory
    return [file dirname [lindex $filehistory 0]]
}

ad_proc ns_puts {{-nonewline:boolean} string} {
    append ns::adp::buffer $string
    if {!$nonewline_p} {
        append ns::adp::buffer \n
    }
}

ad_proc ns_adp_puts {{-nonewline:boolean} string} {
    append ns::adp::buffer $string
    if {!$nonewline_p} {
        append ns::adp::buffer \n
    }
}

ad_proc ns_adp_dir {} {
    return [ns::adp::adpdir]
}

ad_proc ns_adp_abort {} {
    return -code return
}

ad_proc ns_adp_argc {} {
    return [llength $ns::adp::arguments]
}

ad_proc ns_adp_argv {{i ""}} {
    set v $ns::adp::arguments
    if {$i!=""} {set v [lindex $v $i]}
    return $v
}

ad_proc ns_adp_bind_args {args} {
    
    uplevel 1 [list foreach $args [lrange $ns::adp::arguments 1 end] break]
}

ad_proc ns_adp_break {} {
    return -code return
}

ad_proc ns_adp_debug {} {
    error "Not implemented"
}

ad_proc ns_adp_dump {} {
    error "Not implemented"
}

ad_proc ns_adp_eval {} {
    error "Not implemented"
}

ad_proc ns_adp_exception {} {
    error "Not implemented"
}

ad_proc ns_adp_include {filename args} {
    ns_puts [ns::adp::parse 2 $filename $args]
}

ad_proc ns_adp_parse {{-string:boolean} {-file:boolean} filename args} {
    if {!$file_p} {
        error "Not implemented"
    }
    return [ns::adp::parse 2 $filename $args]
}

ad_proc ns_adp_registertag {} {
    error "Not implemented"
}

ad_proc ns_adp_return {} {
    return -code break
}

ad_proc ns_adp_stream {} {
    error "Not implemented"
}

ad_proc ns_adp_tell {} {
    error "Not implemented"
}

ad_proc ns_adp_trunc {} {
    error "Not implemented"
}


