package provide nstclhttpd::fastpath 1.0
package require nstclhttpd::core
package require nstclhttpd::url

namespace eval ns {}
namespace eval ns::fastpath {}

set ns::fastpath::indexfiles [list index.dqe index.adp index.html index.htm]

ns_register_proc GET / ns::fastpath::handle

proc ns::fastpath::handle {} {
    variable indexfiles
    set url [ns_conn url]
    set file [ns_url2file $url]
    if {[catch {file stat $file stat}]} {
        ns_returnnotfound
        return
    }
    switch -- $stat(type) {
        directory {
            if {[string index $url end]!="/"} {
                ns_returnredirect [ns_conn url]/
            }  else  {
                foreach ifile $indexfiles {
                    set if [file join $file $ifile]
                    if {[file exists $if]&&[file isfile $if]} {
                        ns::request::redirect $url$ifile
                    }
                }
            }
        }
        file {
            handlefile $file
        }
    }
}

proc ns::fastpath::handlefile {filename} {
    ns_returnfile 200 [ns_guesstype $filename] $filename 
}

