package provide nstclhttpd::request 1.0
package require nstclhttpd::core

namespace eval ns {}
namespace eval ns::request {}

Url_PrefixInstall / [list ns::request::handle 64]

proc ns::request::init {sock url} {
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata
    set ::ns::sock $sock
    set nsdata(query) [ns_set new "$sock.query"]
    set nsdata(headers) [ns_set new "$sock.headers"]
    set nsdata(outputheaders) [ns_set new "$sock.outputheaders"]
    set nsdata(level) 256
    foreach {n v} $data(headerlist) {
        ns_set put $nsdata(headers) $n $v
    }
    foreach {n v} [Url_DecodeQuery $data(query)] {
        ns_set put $nsdata(query) $n [encoding convertfrom $::ns::encoding $v]
    }
}

proc ns::request::cleanup {sock} {
    # cleanup - after done parsing the page
    ns::set::cleanup $sock
    set ::ns::sock ""
}

proc ns::request::dofilter {sock url when} {
    set filters [ns::url::matchurl filter.$when $url]
    foreach handler $filters {
        set cmd [concat [list [lindex $handler 3]] [lrange [lindex $handler 4] 0 end] [list $when]]
        set crc [catch $cmd rc]
        if {$crc==1} {
            bgerror $rc
        }  elseif  {$crc==3} {
            set rc "filter_break"
            set crc 0
        }  elseif  {$crc==2} {
            set rc "filter_return"
            set crc 0
        }
        if {$crc==0} {
            if {$rc=="filter_break"} {
                return break
            }  elseif {$rc=="filter_return"} {
                return return
            }
        }
    }
    return ok
}

proc ns::request::handle {level sock url} {
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata
    #reload
    Url_QuerySetup $sock
    if {$level<=0} {
        ns_returnnotfound
        return
    }
    set url $data(url)
    init $sock $url

    set nsdata(url) $url
    set nsdata(urlv) [ns::url::urlsplit $url]

    set preauth [dofilter $sock $url preauth]
    if {$preauth=="return"} {return}

    # TODO: authorize

    set postauth [dofilter $sock $url postauth]
    if {$postauth=="return"} {return}

    redirect $data(url)

    set trace [dofilter $sock $url trace]

    ns_returnnotfound
    return
}

proc ns::request::redirect {url} {
    upvar #0 ::ns::sock sock
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata

    set nsdata(url) $url
    set nsdata(urlv) [ns::url::urlsplit $url]

    set matches [ns::url::matchurl proc $url]
    if {[incr nsdata(level) -1]<=0} {return}

    if {[llength $matches]==0} {
        ns_returnnotfound
        return
    }
    set handler [lindex $matches 0]
    set cmd [concat [list [lindex $handler 3]] [lrange [lindex $handler 4] 0 end]]
    if {[catch $cmd rc]==1} {
        bgerror $rc
    }
}

