package provide nstclhttpd::respond 1.0
package require nstclhttpd::core

namespace eval ns {}
namespace eval ns::request {}

proc ns::request::_outputheaders {} {
    set sock $::ns::sock
    if {$sock==""} {
        return
    }
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata

    ns::set::seteval $nsdata(outputheaders) oh
    set data(outputheaders) $oh
}
proc ns::request::respond_data {type body code} {
    set sock $::ns::sock
    if {$sock==""} {
        return
    }
    
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata

    ns::request::_outputheaders
    Httpd_ReturnData $sock $type [encoding convertto $::ns::encoding $body]
    ns::request::cleanup $sock
}
proc ns::request::respond_bindata {type body code} {
    set sock $::ns::sock
    if {$sock==""} {
        return
    }
    
    upvar #0 ::Httpd$sock data
    upvar #0 ::ns::data$sock nsdata

    ns::request::_outputheaders
    Httpd_ReturnData $sock $type $body
    ns::request::cleanup $sock
}

proc ns::request::respond_error {code} {
    respond_data text/plain "Error $code" $code
}

ad_proc ns_return {code type body} {
    ns::request::respond_data $type $body $code
}

ad_proc ns_returnnotfound {} {
    ns::request::respond_error 404
}

ad_proc ns_returnadminnotice {status msg {longmsg ""}} {
    error "Not implemented"
}

ad_proc ns_returnbadrequest {reason} {
    error "Not implemented"
}

ad_proc ns_returnerror {status msg} {
    error "Not implemented"
}

ad_proc ns_returnfile {status type filename} {
    set sock $::ns::sock
    if {$sock==""} {return ""}
    set fh [open $filename r]; fconfigure $fh -translation binary; set fc [read $fh]; close $fh
    ns::request::respond_bindata $type $fc $status
}

ad_proc ns_returnforbidden {} {
    ns::request::respond_error 403
}

ad_proc ns_returnfp {status type fileId len} {
    error "Not implemented"
}

ad_proc ns_returnnotice {status msg {longmsg ""}} {
    error "Not implemented"
}

ad_proc ns_returnredirect {location} {
    ns::request::_outputheaders
    Httpd_Redirect $location [ns::sock]
    ns::request::cleanup $sock
}

ad_proc ns_returnunauthorized {} {
    ns::request::respond_error 401
}

