ad_page_contract {

    Stores the system/publisher names and some email addresses,
    provided by the user on the <code>site-info</code> form, in the
    server configuration.

    @author Jon Salz (jsalz@arsdigita.com)
    @author Bryan Quinn (bquinn@arsdigita.com)
    @cvs-id $Id: site-info-2.tcl,v 1.4 2002/07/03 09:16:25 jeffd Exp $
} {
    system_url:notnull
    system_name:notnull
    publisher_name:notnull
    system_owner:notnull
    admin_owner:notnull
    host_administrator:notnull
    outgoing_sender:notnull
    new_registrations:notnull
}

set kernel_id [db_string acs_kernel_id_get {
    select package_id from apm_packages
    where package_key = 'acs-kernel'
}]

foreach { var param } {
    system_url SystemURL
    system_name SystemName
    publisher_name PublisherName
    system_owner SystemOwner
    admin_owner AdminOwner
    host_administrator HostAdministrator
    outgoing_sender OutgoingSender
} {
    ad_parameter -set [set $var] -package_id $kernel_id $param
}

# set the Main Site RestrictToSSL parameter

set main_site_id [db_string main_site_id_select { 
    select package_id from apm_packages
    where instance_name = 'Main Site' 
}]

ad_parameter -set "acs-admin/*" -package_id $main_site_id RestrictToSSL
ad_parameter -set $new_registrations -package_id $main_site_id NewRegistrationEmailAddress

ad_returnredirect "/?done_p=1"
